
 
void setup()
    {
      size( 1460, 500);
      // set background to white
      background(0);
      //activate smoothing anti-aliasing functions between pixels
      smooth();
      // set framerate to 10 per second. NOrmal video is 30 or 60
      frameRate( 10);
      //Print out the text in the command prompt once the program reaches here
      println( " setup done");
      
    
      //in this step we copy the data from the csv file into our own table.
      //we use header flag to tell processing to ignore the first line of the csv file as it contains the names of the columns
      table = loadTable( "800.csv", "header");
      
      // assign these variables to contain the number of rows and columns from myTable
      numRows = table.getRowCount();
      numCols = table.getColumnCount();
      
      
      // initialize the 2D array with number of rows and columns
      
      
      
      // copy everything from table into a 2D array
      // use two for loops to iterate over both rows and columns
      // this step is not necessary, but helps in matrix manipulations which we will be doing later
      
      for ( int i = 0 ; i< numRows ; i++)          // a for loop where i is set to 0  and increments all the way to numRows by 1
          {
            if(table.getInt(i,0) == 800){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[0][month-13] = dataMatrix[0][month-13]+1; 
               }
             }
            } 
             if(table.getInt(i,0) == 810){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[1][month-13] = dataMatrix[1][month-13]+1; 
               }
             }
             } 
             if(table.getInt(i,0) == 820){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[2][month-13] = dataMatrix[2][month-13]+1; 
               }
             }
             } 
             if(table.getInt(i,0) == 830){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[3][month-13] = dataMatrix[3][month-13]+1; 
               }
             }
             } 
             if(table.getInt(i,0) == 840){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[4][month-13] = dataMatrix[4][month-13]+1; 
               }
             }
             } 
             if(table.getInt(i,0) == 50){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[5][month-13] = dataMatrix[5][month-13]+1; 
               }
             } 
            }if(table.getInt(i,0) == 860){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[6][month-13] = dataMatrix[6][month-13]+1; 
               }
             } 
            }if(table.getInt(i,0) == 870){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[7][month-13] = dataMatrix[7][month-13]+1; 
               }
             } 
            }if(table.getInt(i,0) == 880){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[8][month-13] = dataMatrix[8][month-13]+1; 
               }
             } 
            }if(table.getInt(i,0) == 890){
              int j = 1;
              for( int month =13; month<72; month++)
             {
               if(table.getInt(i, j) == month)
               {
                dataMatrix[9][month-13] = dataMatrix[9][month-13]+1; 
               }
             } 
            }
          }
       
       ///bubble sort columns
       
       int [] columnSort = new int[56];
       
       for(int i = 0; i<56; i++)
       {
         for(int j =0; j<10; j++)
         {
           columnSort[j]+=dataMatrix[j][i]; 
         }
       }
        
        int [][] columnS = new int[56][2];
      for(int i =0; i<56; i++)
      {
        columnS[i][0] = columnSort[i];
        columnS[i][1] = i; 
      }
      
      for(int i = 0; i<55; i++)
      {
        if(columnS[i][0] > columnS[i+1][0])
        {
          int temp = columnS[i][0];
          int temp2 = columnS[i][1];
          columnS[i][0]=columnS[i+1][0];
          columnS[i][1]=columnS[i+1][1];
          columnS[i+1][0] = temp;
          columnS[i+1][1] = temp2; 
        }
      }       
      
      
      for(int i=0; i<56; i++)
      {
         int cols = columnS[i][1];
         for(int j =0; j<10; j++)
        {
           newData[j][i] = dataMatrix[j][cols];
           println("new data: "+newData[j][i] + " "+j+ " " + i+ " = dataMatrix " +dataMatrix[j][cols]+ " " + j + " " + cols + " ");
        } 
      }
       
       
     //bubble sort rows
   
   
   int [] rowSort = new int[10];
       
       for(int i = 0; i<10; i++)
       {
         for(int j =0; j<56; j++)
         {
           columnSort[i]+=dataMatrix[i][j]; 
         }
       }
        
        int [][] rowS = new int[10][2];
      for(int i =0; i<10; i++)
      {
        rowS[i][0] = rowSort[i];
        rowS[i][1] = i; 
      }
      
      for(int i = 0; i<9; i++)
      {
        if(rowS[i][0] > rowS[i+1][0])
        {
          int temp = rowS[i][0];
          int temp2 = rowS[i][1];
          rowS[i][0]=rowS[i+1][0];
          rowS[i][1]=rowS[i+1][1];
          rowS[i+1][0] = temp;
          rowS[i+1][1] = temp2; 
        }
      }       
      
      
      for(int i=0; i<10; i++)
      {
         int row = rowS[i][1];
         for(int j =0; j<56; j++)
        {
           newRData[i][j] = dataMatrix[row][j];
           //println("new data: "+newData[j][i] + " "+j+ " " + i+ " = dataMatrix " +dataMatrix[j][row]+ " " + j + " " + row + " ");
        } 
      }
       
       
       
     sumOfRows = new float[10];
     for ( int  i = 0 ; i< 10; i++)
           sumOfRows[i] =0;
           
      // we will be using another array to keep track of the row changes that happen
      // during reordering
      //right now they are being set from row 0.......6
      
      trackerOfRowChanges = new float[10];
      for ( int  i = 0 ; i< 10 ; i++)
           trackerOfRowChanges[i] =i;     
          
      columnWeights = new float[58];
      println("sum of rows: "+ sumOfRows.length);
      println("numRows" + numRows);
      // summing up all the values for a particular row , mutiplying by columnWigths is optional
      for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = 0; j< 58 ; j++ )
                {                 
                 sumOfRows[i] += dataMatrix[i][j]; 
                }
          }
      
      //creating a copy of it    
      for ( int  i = 0 ; i< 10 ; i++)    
          CopyOfSumOfRows[i] = sumOfRows[i];
      
      //reordering the matrix
       /* here is what we want to accompalish here:
        this algorithm is called bubble sort , for more details: http://en.wikipedia.org/wiki/Bubble_sort
        the idea is to swap values if a lower value is encountered in the array
        to make things complicated we will have to swap everything that is asscociated with row
        i.e the rowNumbers and the day asscociated for visualization
        */
      for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = i+1; j< 10 ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfRows[i] > CopyOfSumOfRows[j] )
                     {
                       // switching numbers
                       float temp = CopyOfSumOfRows[i];
                       CopyOfSumOfRows[i] = CopyOfSumOfRows[j];
                       CopyOfSumOfRows[j] = temp;
                       
                       // tracking changes in rows
                       float tempRow = trackerOfRowChanges[i];
                       trackerOfRowChanges[i] = trackerOfRowChanges[j];
                       trackerOfRowChanges[j] = tempRow;
                       
                       String tempMonth = deweyOrdered [i];
                       deweyOrdered[i] = deweyOrdered [j];
                       deweyOrdered[j] = tempMonth;

                     }
                }
          }
     
       //once we have the new positions, we can create a new 2D array and store all the values into it.
      // lets call it rowWeightedArray
       for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = 0; j< 58 ; j++ )
                {
                  
                  float pointerToCorrectRow =  trackerOfRowChanges[i];
                  rowWeightedArray[i][j] = dataMatrix[int(pointerToCorrectRow)][j];
                                                   
                }
          }
          
    //////////////////////////////////////////////////////////////////////////////////      
    // ok now lets arrange the array by columns, the same process is repeated
       
    // initalizing weighted sums
      for ( int  i = 0 ; i< 58 ; i++)
           sumOfColumns[i] =0;
      
      // initalizing column numbers
      for ( int  i = 0 ; i< 58 ; i++)
           trackerOfColumnChanges[i] =i;     
           
      // weighting each column and summing it up
      for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = 0; j< 58 ; j++ )
                {                 
                 sumOfColumns[j] += dataMatrix[i][j]; 
                }
          }
          
          
       // copying to a new column   
       for ( int  i = 0 ; i< 58 ; i++)    
           CopyOfSumOfColumns[i] = sumOfColumns[i];
      
      //reordering the matrix, we perform bubble sort againg , but keep track of the columns this time
      for ( int  i = 0 ; i< 58 ; i++ )
          {
            for ( int j = i+1; j< 58 ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfColumns[i] > CopyOfSumOfColumns[j] )    //check if jth column value is greater than the ith one
                     {
                       // switching numbers
                       float temp = CopyOfSumOfColumns[i];
                       CopyOfSumOfColumns[i] = CopyOfSumOfColumns[j];
                       CopyOfSumOfColumns[j] = temp;
                       
                       // tracking changes in cols
                       float tempColumns = trackerOfColumnChanges[i];
                       trackerOfColumnChanges[i] = trackerOfColumnChanges[j];
                       trackerOfColumnChanges[j] = tempColumns;
                       
                       //swapping the strings for the years
                       String tempMonth = monthsOrdered [i];
                       monthsOrdered[i] = monthsOrdered [j];
                       monthsOrdered[j] = tempMonth;

                     }        
                }
          }   
          
     // creating new column weighted array base on the index ( trackerOfColumn)
       
       for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = 0; j< 58 ; j++ )
                {
                  
                  int pointerToCorrectColumn =  int ( trackerOfColumnChanges[j] ) ;
                  columnWeightedArray[i][j] = dataMatrix[i][pointerToCorrectColumn];
                                                   
                }
          }
          
     for(int row = 0; row < columnWeightedArray.length; row++){
        for(int col = 0; col < columnWeightedArray[row].length / 2; col++) {
            float temp = columnWeightedArray[row][col];
            columnWeightedArray[row][col] = columnWeightedArray[row][columnWeightedArray[row].length - col - 1];
            columnWeightedArray[row][columnWeightedArray[row].length - col - 1] = temp;
        }
    }
      
        // simple algo to find the maxCount    
        for ( int  i = 0 ; i< 10 ; i++ )
          {
            for ( int j = 0; j< 58 ; j++ )
                {
                  
                 if( maxCount < dataMatrix[i][j])
                    maxCount = dataMatrix[i][j];
         
                }
          }
       
       
       for( int i=0; i<10; i++)
        {
         for( int j = 0; j < 58; j++)
        {
           println("dewey= " +i+ " month = "+ j + ": " + dataMatrix[i][j] + " ");
        } 
       }
     
    }

